#pragma once

#include <utils.h>

typedef struct layer_type_info
{
	char type_name[100];
} LayerTypeInfo;

//enum AvailableRenderableTypes
//{
//	NOISE_SLICE,
//	SQUARE_LAYER,
//
//	//special one, not really a layer:
//	RENDERABLE_TYPE_COUNT
//};

class RenderableFactory
{
public:
	~RenderableFactory(void);
	static Renderable* CreateRenderable(int renderable_type);
	static LayerTypeInfo TypeInformation[];
	static int LayerTypeCount;
private:
	//static functions only
	RenderableFactory(void);
};