//util functions and structs.

#pragma once


// [WODE]
#ifdef __APPLE__
	#include <Glut/glut.h>
	#include <Glui/glui.h>
#else
	#include <freeglut.h>
	#include <glui.h>
#endif 

#include <string.h>
#include <assert.h>
#include <stdio.h>

class LayerManager;
class Renderable;

#define MAX(a,b) ((a>b)?(a):(b))
#define MIN(a,b) ((a<b)?(a):(b))

#define ABS(a) ((a<0)?(-a):(a))

#define WINDOW_WIDTH	600
#define WINDOW_HEIGHT	500

struct RECTFLOAT
{
	float left, top, right, bottom;
};

/**
* A kind of "modulo" function for floats.
* returns the remainder after dividing a by b.
*/
float ModFloat(float a, float b);

//like div for int, but returns the whole amount of a / b, in float.
float DivFloat(float a, float b);

//debug helper, just drop this in anywhere.
#define LOG(string, ...)			WCHAR ____text[500]; _snwprintf_s(____text, 500, string L"\r\n", __VA_ARGS__); OutputDebugString(____text);

typedef struct _POINT_FLOAT {
    float   x;
    float   y;
} POINT_FLOAT, *PPOINT_FLOAT;

// [WODE]
#ifdef __APPLE__
	#define sprintf_s sprintf
	#define strcpy_s strcpy
#endif